/* Copyright (C) 2003 Benjamin Marwede */

var x1,x2,y1,y2;

a_className = new Array( rows );
a_innerHTML = new Array( rows );
a_title     = new Array( rows );
for( i=0; i < rows; i++ ){
  a_className[i] = new Array( cols );
  a_innerHTML[i] = new Array( cols );
  a_title[i]     = new Array( cols );
}

function checkPosition( x, y ){
  if( (x<1) || (x>cols) || (y<1) || (y>rows) ){
    if( debug )alert( "Error: Index out of bound at " + String.fromCharCode(y+64) + x + ". Specify position between A1 and " + String.fromCharCode(rows+64) + cols + "!" );
    return 1;
  }
  return 0;
}

function checkRect( x1, y1, x2, y2 ){
  if( (x1>x2) || (y1>y2) ){
    if( debug )alert( "Error: " + String.fromCharCode(y1+64) + x1 + " should be more right and below than or equal to " + String.fromCharCode(y2+64) + x2 + "!" );
    return 1;
  }
  return 0;
}

function parsePositionX( pos ){
  x = parseInt( pos.substr(1), 10 );
  return isNaN(x) ? 0 : x;
}

function parsePositionY( pos ){
  y = pos.charCodeAt(0);
  return y>96 ? y-96 : y-64;
}

function setCharacter( pos, file, name, weapon, condition, portrait, player ){
  x = parsePositionX( pos );
  y = parsePositionY( pos );
  if( checkPosition( x, y ) )return;
  a_innerHTML[y-1][x-1] = "<img src=\"" + file + "\" onmouseover=\"status='" + String.fromCharCode(y+64) + x + " - Charakter: " + name + " - Waffe: " + weapon + " - Zustand: " + condition + " - Spieler: " + player + " - klicken f&uuml;r Portrait...';return true;\" onmouseout=\"status='';return true;\" onclick=\"window.open('" + portrait + "','_blank','height=300,location=no,menubar=no,resizable=no,scrollbars=no,status=no,toolbar=no,width=250')\">";
}

function setTerrain( pos, terrain ){
  x = parsePositionX( pos );
  y = parsePositionY( pos );
  setTerrainXY( x, y, terrain );
}

function setTerrainXY( x, y, terrain ){
  if( checkPosition( x, y ) )return;
  a_className[y-1][x-1] = terrain;
  a_title[y-1][x-1] = String.fromCharCode(y+64) + x + ": " + getTerrainName( terrain );
}

function setTerrainCircle( pos, r, terrain ){
  if( isNaN( r ) )r = parseInt( r );
  x = parsePositionX( pos );
  y = parsePositionY( pos );
  if( checkPosition( x, y ) )return;
  for( i = x-r; i <= x+r; i++ )for( j = y-r; j <= y+r; j++ )if( (i>0) && (i<=cols) && (j>0) && (j<=rows) && (Math.round( Math.sqrt( Math.pow(x-i,2) + Math.pow(y-j,2) ) )==r) )setTerrainXY( i, j, terrain );
}

function setTerrainCircleSolid( pos, r, terrain ){
  if( isNaN( r ) )r = parseInt( r );
  x = parsePositionX( pos );
  y = parsePositionY( pos );
  if( checkPosition( x, y ) )return;
  for( i = x-r; i <= x+r; i++ )for( j = y-r; j <= y+r; j++ )if( (i>0) && (i<=cols) && (j>0) && (j<=rows) && (Math.round( Math.sqrt( Math.pow(x-i,2) + Math.pow(y-j,2) ) )<=r) )setTerrainXY( i, j, terrain );
}

function setTerrainRect( pos1, pos2, terrain ){
  x1 = parsePositionX( pos1 );
  y1 = parsePositionY( pos1 );
  x2 = parsePositionX( pos2 );
  y2 = parsePositionY( pos2 );
  if( checkPosition( x1, y1 ) )return;
  if( checkPosition( x2, y2 ) )return;
  if( checkRect( x1, y1, x2, y2 ) )return;
  for( i = x1; i <= x2; i++ )for( j = y1; j <= y2; j++ )if( (i==x1) || (i==x2) || (j==y1) || (j==y2) )setTerrainXY( i, j, terrain );
}

function setTerrainRectSolid( pos1, pos2, terrain ){
  x1 = parsePositionX( pos1 );
  y1 = parsePositionY( pos1 );
  x2 = parsePositionX( pos2 );
  y2 = parsePositionY( pos2 );
  if( checkPosition( x1, y1 ) )return;
  if( checkPosition( x2, y2 ) )return;
  if( checkRect( x1, y1, x2, y2 ) )return;
  for( i = x1; i <= x2; i++ )for( j = y1; j <= y2; j++ )setTerrainXY( i, j, terrain );
}
